/* yasep/tool/asm.js
  This file is distributed under terms of the Affero GPL v3 license or later, see http://yasep.org
 created mar. sept. 13 08:49:01 CEST 2011
 The successor of the "floating assembler window" :-)
 version lun. oct. 17 05:51:23 CEST 2011 : adding stuff from yasep/JSgui/floating_asm.js
 */

init_obj.push(asmwin={
  win: null,
  size_id: null,
  space_regex:new RegExp("([&][Nn][Bb][Ss][Pp][;])|([%]20)|([%]C2[%]A0)","g"),

  update_asm: function(){
    if (Y.encode_instruction(asmwin.value_asm.value, asmwin.ASM)) {
      asmwin.value_hex.value=int2hex(asmwin.ASM.encoded_instruction,
        2*asmwin.ASM.encoded_size_bytes-1,2*asmwin.ASM.encoded_size_bytes-1);
      asmwin.size_id.innerHTML=asmwin.msgsize+asmwin.ASM.encoded_size_bytes+asmwin.msgunit;
    }
    else {
      asmwin.value_hex.value="";
      asmwin.size_id.innerHTML="";
    }
    return false;
  },

  update_hex: function(){
    Y.DISASM(str2int(asmwin.value_hex.value), asmwin.DISASM);
    if (asmwin.DISASM.form!=null) {
      asmwin.value_asm.value=asmwin.DISASM.instruction;
      asmwin.size_id.innerHTML=asmwin.msgsize+asmwin.DISASM.size_bytes+asmwin.msgunit;
    }
    else {
      asmwin.asm_form.value_asm.value="error";
      asmwin.size_id.innerHTML="";
    }
    return false;
  },

  trigger_asm: function(loc){
    if (loc!="") {
      // some escape sequence cleanup :
      loc=loc.replace(asmwin.space_regex," ");

      var i=loc.indexOf("?");
      if (i==1){
        var a=loc.slice(2);
        if (loc[0]=="a") {
          if (a) {
            asmwin.value_asm.value=unescape(a);
            asmwin.update_asm();
          }
        }
        else
          if (loc[0]=="d") {
            if (a) {
              asmwin.hex_form.value_hex.value=unescape(a);
              asmwin.update_hex();
            }
          }
      }
    }
  },

  start: function() {
    var h, i, cont=document.createElement("DIV");
    cont.innerHTML=import_htmi("tool/asm");
    // modify the <a> tags to change the style and hook the proper handling routines
    winman.patchInnerLinks(cont);

    h=getByClass("hiddenDiv","DIV",cont);
    asmwin.win = ygwm.new_window(
       hiddenText(0,h), null, cont,
       600, 400, 250, 150, false, true, true, true, false, "doc_cygr");  // create a new style for ASM
   // X & Y should be changed if a click opened the window
    asmwin.msgsize=hiddenText(2,h);
    asmwin.msgunit=hiddenText(3,h);

    asmwin.size_id=getById("ASM_size_id","SPAN",cont);
    asmwin.messages=getById("ASM_messages","DIV",cont);

    i=message_FIFO(asmwin.messages);
    asmwin.ASM   = new    Y.ASM_context(i);
    asmwin.DISASM= new Y.DISASM_context(i);
    i("blue", hiddenText(1,h)); // first message, remove the error message.

    document["asm_form"].onsubmit=
      getById("submitAsm","*",cont).onclick=asmwin.update_asm;
    
    document["hex_form"].onsubmit=
      getById("submitDisasm","*",cont).onclick=asmwin.update_hex;

    asmwin.value_asm=getById("value_asm","*",cont);
    asmwin.value_hex=getById("value_hex","*",cont);

    asmwin.win.trigger=asmwin.trigger_asm;
    asmwin.cont=cont;
    return asmwin.win;
  },

  init_obj: function(){
    asmwin.menuItem = menu.subMenuItem(menu.mainMenuItem("Tools"),"Assembler", "tool/asm");
  }
});
